#include <v_lib.h>
#include "v_uievt.h"
#include "ui_event.c"

#define N 10000

int main(void)
{
	ui_event_t a;
	vsize_t count, len;

	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);

#if 0
    
    a.type = 0;
    uiPushEvent(&a);
    a.type = 1;
    uiPushEvent(&a);
    a.type = 2;
    uiPushEvent(&a);
    a.type = 3;
    uiPushEvent(&a);
    printf("four pushes, count %d\n",uiEventsQueued());
    puts("from head:");
    for(count = 0;count < uiEventsQueued();count++)
    	printf("%d\t\n",uiPeekEvent(count)->type);
    puts("from tail:");
    for(count = 0;count < uiEventsQueued();count++)
    	printf("%d\t\n",uiPeekLastEvent(count)->type);
    puts("removing 2;");
    for(count = 0;count < uiEventsQueued();count++)
    	if(uiPeekEvent(count)->type == 2)
    	{
    		uiRemoveEvent(count,&a);
    		printf("Found: type %d\n",a.type);
    		break;
    	}
    printf("count %d\n",uiEventsQueued());
    puts("from head:");
    for(count = 0;count < uiEventsQueued();count++)
    	printf("%d\t\n",uiPeekEvent(count)->type);
    puts("from tail:");
    for(count = 0;count < uiEventsQueued();count++)
    	printf("%d\t\n",uiPeekLastEvent(count)->type);
    puts("getting all:");
    while(uiNextEvent(&a))
    	printf("%d\t\n",a.type);

#endif

	printf("Storing %d events... \n",N);
	for(count = 0;count < N;count++)
	{
		a.type = count;
		uiPushEvent(&a);
	}

	printf("Removing %d events ...\n",N);
	while(uiRemoveEvent(0,NULL));

	printf("Storing %d events... \n",N);
	for(count = 0;count < N;count++)
	{
		a.type = count;
		uiPushEvent(&a);
	}

	printf("Removing %d events in random order...\n",N);
	
	for(len = uiEventsQueued();len;len--)
	{
		count = rand() % len;
		uiRemoveEvent(count,NULL);
	}
	
	memPrintStats();
	return 0;
}
